// Propagation non-linaire d'une impulsion brve
// Spectre gaussien
// Units rduites

exec('femto.sci');

// Paramtres
nPoints = 2048;
[nu,t] = ftAxis(nPoints,40);
omega = (2*%pi)*nu;
field_t0 = exp(-sqr(t)-%i*2*%pi*t/.2);
field_nu0 = ift(field_t0);
maxValue = max(abs(field_nu0)); // Pour normaliser le spectre

// Paramtres de la simulation
zMax = 4;   // distance de propagation (en mm)
g = 4*%pi/zMax; // Dphasage non-linaire de 4pi  l'issue de la propagation
z = 0:zMax/100:zMax; // Axe de propagation

map = zeros(length(z),nPoints); // carte |A(z,t)|^2

// Calcul du champ pour les valeurs successives de z
for iZ = 1:length(z) 
  phase = g*sqr(abs(field_t0))*z(iZ);
  field_t = field_t0.*exp(%i*phase);
  scf(1);       // Slection de la fentre n1
  drawlater();  // Ne pas dessiner tout de suite pour viter un clignotement de l'affichage
  clf();        // Effacer le graphe prcdent
  plot(t,real(field_t)); // reprsentation du champ lectrique (en fs)
  xlim([-3 3]);
  ylim([-1 1]);
//  xtitle(["z = " string(z(iZ)/1000) "mm "]);
  drawnow();    // Maintenant que c'est prt, on peut dessiner la figure
  
  // Reprsentation graphique de l'intensit spectrale
  field_nu = ift(field_t);
  scf(2); drawlater(); clf();
  plot(nu,sqr(abs(field_nu)/maxValue));
  xlim([0 10]);
  ylim([0 1]);
  xlabel("Frquence");
  ylabel("|E(nu)|^2");
  drawnow();
  map(iZ,:) = sqr(abs(field_nu)/maxValue); // Stockage de l'intensit spectrale
end;

// Reprsentation graphique de l'intensit spectrale le long de l'axe de propagation
scf(3); clf();
drawlater();
setColorMap(1);
grayplot(z,nu,map);
xlabel("z");
ylabel("Frquence");
ylim([0 10]);
drawnow();
xtitle("Evolution du spectre en fonction de z");
