// Propagation non-linaire d'une impulsion brve en rgime soliton
// Units rduites

exec('femto.sci');

// Paramtres
nPoints = 512;
[nu,t] = ftAxis(nPoints,5);
omega = (2*%pi)*nu;
k2 = -1;   // Dispersion ngative
g = 1;     // Non-linarit
dz = 0.01; // Pas d'intgration
zMax = 3;  // Distance totale de propagation
z = 0:dz:zMax; // Axe de propagation
 
// Champ lectrique
field_t = ones(1,nPoints)./(cosh(t)); // Scante hyperbolique
// Ajout d'une gaussienne dcale en temps et en frquence
t0 = -20;
nu0 = -2;
field_t = field_t+exp(-sqr(t-t0)).*exp(-%i*2*%pi*nu0*t);
field = ift(field_t);

map = zeros(length(z),nPoints); // carte |u(z,t)|^2

// Rsolution de l'quation diffrentielle par la mthode du pas fractionne
for iZ = 1:length(z)
  // Domaine temporel (traitement de la non-linarit)
  field_t = ft(field);
  phase_t = g*sqr(abs(field_t))*dz; // Phase temporelle (effet Kerr)
  field_t = field_t .*exp(%i*phase_t);
  // Reprsentation graphique de l'intensit temporelle
  scf(1); drawlater(); clf();
  plot(t,sqr(abs(field_t)));
  xlabel("Temps");
  ylabel("|u(t)|^2 ");
  ylim([0 1]);
  drawnow();
  map(iZ,:) = sqr(abs(field_t)); // Stockage de l'intensit temporelle
  
  // Domaine spectral (traitement de la dispersion)
  field = ift(field_t);
  phase = .5*k2*dz*sqr(omega); // Phase spectrale (dispersion quadratique)
  field = field .*exp(%i*phase);
  // Reprsentation graphique de l'intensit spectrale
  scf(2); drawlater(); clf();
  plot(nu,abs(field));
  xlabel("Frquence");
  ylabel("|u(nu)|^2 ");
  drawnow();

end;

// Reprsentation graphique de l'intensit temporelle le long de l'axe de propagation
scf(3); clf();
setColorMap(1);
grayplot(z,t,map);
xlabel("z");
ylabel("|u(t)|^2");
ylim([-25 25]);
xtitle("Collision entre une gaussienne et un soliton");
